#!/usr/bin/perl -w

# Nom du programme:find_and_mask_ms.pl (modified from mask_ms.pl and extract_perfect_microsat_with_hach.pl)

#INPUT: xxx.fas (file with all sequences in it (adaptor already cut))

# Finds all microsat of a sequence 
# $minx is the minimum number of repeats for all motifs, where X is the lenght of the motif (e.g. $min2 is the minimum mumber of dinucleotide repeats)

# Put sequences into fasta file 
# works with multiple files with multiple sequences in it
# ONE FILE PER SPECIES

#OUTPUT:
#xxx_mask.fas # if $keep_non_ms == 1 writes all sequences infor fasta file, If 0, writes aonly sequences with ms in it in fasta file (ms is masked by lowercase))
#(fasta file with all sequences in it, ms (if present) are masked by lowercase letters)


# xxx.seq (info on seq)
# [0] SEQ_CODE
# [1] NUMBER OF MS
# [2] SEQ_LENGTH
# [3] MS MOTIF
# [4] MS FIRTS POS
# [5] MS LAST POS
# [6] NUMBER OF REP
# [3-6] REPEATED FOR ALL MS



  use warnings;
  use strict;
  use subprogramEM;


 # my $USAGE = "USAGE : $0 filename_with_pathway folder_for_the_outfiles minimum_number_of_repeats_for_2-3-4-5-6-bp_motifs minimum_number_of_repeats_for_single-bp_motifs E_value_for_checking_vector_contamination pathway_for_BLAST\n\n";

	my $min1 = 0;
	my $min2 = 0;
	my $min3 = 0;
	my $min4 = 0;
	my $min5 = 0;
	my $min6 = 0;
	my $del_prev_mask = 0;
	my $keep_non_ms = 0;
	my $folder = '';
	my $outfolder = '';
	my $file_motif = '';


  if ( scalar@ARGV == 11 )
  {
     	$min1 = $ARGV[0];
	$min2 = $ARGV[1];
	$min3 = $ARGV[2];
	$min4 = $ARGV[3];
	$min5 = $ARGV[4];
	$min6 = $ARGV[5];
	$del_prev_mask = $ARGV[6];
	$keep_non_ms = $ARGV[7];
	$folder = $ARGV[8];
	$outfolder = $ARGV[9];
	$file_motif = $ARGV[10];
  }

else
{
	$min1 = 4;
	$min2 = 2;
	$min3 = 2;
	$min4 = 2;
	$min5 = 2;
	$min6 = 2;
# if $del_prev_mask = 0; keeps previous lower case masking, else deletes previous masking
	$del_prev_mask = 1;
# if 1 writes all sequences info fasta file, If 0, writes only sequences with ms in it in fasta file (ms is masked by lowercase))
	$keep_non_ms = 0;
	$folder = 'datatemp1';
	$outfolder = 'temp1';
	$file_motif = '\.fas';
}


  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $filename (@filenames)
{
if ($filename =~ /$file_motif$/)
{
    my $seq_file = $filename;
    $seq_file = $outfolder.'/'.$seq_file; 
    $seq_file =~ s/\.fas/\.seq/;
    open_file_out($seq_file, 'SEQ');
	my $fas_file = $filename;
	$fas_file = $outfolder.'/'.$fas_file;
	$fas_file =~ s/\./_mask\./;
	open_file_out($fas_file, 'FAS');
    $filename = $folder.'/'.$filename; 

	my $m = 0;

 print SEQ "seq_code;number_of_ms;seq_length;ms_motif;ms_first_pos;ms_last_pos;number_of_rep\n";

open_file_in($filename, 'DATA');
    while (my $seq = one_seq($filename))
    {
	if ($seq eq '>')
	{
		next;
	}
	$seq =~ /.+\n/;
	my $code = $&;
	$seq =~ s/$code//;
	$seq =~ s/>//;
	$seq =~ s/\s//g;
	chomp $seq;
	$code =~ s/\s.*//;
	chomp $code;

    my %seq1 = ();

       my $seq_length = length $seq;

	my %ms_motif = ();
	my %ms_pos = ();

	if ($del_prev_mask == 1)
	{
		$seq = uc $seq;
	}
#	print "$seq\n";
#¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤
	find_microsat_gb_motif_def_6($seq, \%ms_motif, \%ms_pos, $min1, $min2, $min3, $min4, $min5, $min6);
#¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤
    my @ms = sort {$a <=> $b} keys %ms_pos;
    my $ms_numb = scalar @ms;
	if (scalar@ms > 0)
	{
		++$m;
		    my $fragment_l = change_ms_into_lower_case($seq, \%ms_pos);
		print FAS ">$code\n$fragment_l\n";
	}
	elsif ($keep_non_ms == 1)
	{
		print FAS ">$code\n$seq\n";
	}
	else
	{
		next;
	}

#print info into seq file
    print SEQ "$code;$ms_numb;$seq_length;";
    foreach my $ms (@ms)
    {
	my $ms_length = $ms_pos{$ms} - $ms +1;
	my $rep_length = length $ms_motif{$ms};
	my $rep_numb = $ms_length/$rep_length;
	print SEQ "$ms_motif{$ms};$ms;$ms_pos{$ms};$rep_numb;";
    }
    print SEQ "\n";

#print_hachage(\%ms_pos);
#print_hachage(\%ms_motif);

# while
    }
    close DATA;
    close SEQ;
	close FAS;
#print "Number of sequences with ms in it: $m\n";
# end if file_motif
}
#end of foreach file
}

exit;


############################################################


sub one_seq
{
#    read the data concernant one sequence

    my ($filename) = @_; 
    my ($res_seq) = ''; 

    my ($sep_entree) = $/;
    $/ = ">";
    $res_seq = <DATA>;
    $/ = $sep_entree;
    return $res_seq;
}


##########################################################
