#!/usr/bin/perl -w

# prg: sort_length.pl
# read all fasta files in input folder
# if sequence is shorter than predefined limit, put it into a fasta file, if longer, put it into
#another

#INPUT: xxx.fas 
#OUTPUT: xxx_80.fas (seqs longer than limit)
#	xxx_bellow80.fas (seqs shorter than limit)


  use warnings;
  use strict;
  use subprogramEM;

my $syst = '';
my $folder = '';
my $outfolder = '';
my $limit = '';
my $motif = '';

if ( scalar@ARGV == 5 )
{
   	$syst = $ARGV[0];
   	$folder = $ARGV[1];
   	$outfolder = $ARGV[2];
   	$limit = $ARGV[3];
	$motif = $ARGV[4];
}
else
{
	$syst = 'win';
	$folder = 'datatemp1';
	$outfolder = 'temp1';
	$limit = 80;
	$motif = '\.wov';
}

  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

#my $outfile = $outfolder.'\Apis_summary.txt';
#open_file_out($outfile, 'OUT');

foreach my $filename (sort @filenames)
{
if ($filename =~ /$motif$/)
{
	my $short = $filename;
	$short =~ s/\..*/_bellow$limit\.fas/;
	$short = $outfolder.'/'.$short;
	my $long = $filename;
	$long =~ s/\..*/_$limit\.fas/;
	$long =~ s/\./bp\./;
	$long = $outfolder.'/'.$long;
	open_file_out($short, 'SH');
	open_file_out($long, 'LO');
    $filename = $folder.'/'.$filename;
    open (FAS, $filename);


    my $i = 0;
	my $ok = 0;

while (my $seq = one_seq($filename))
    {
		if ($seq eq '>')
		{
			next;
		}
		$seq =~ /.*\n/;
		my $code = $&;
		$seq =~ s/$code//;
		$code =~ s/\s.*//;
		chomp $code;
		$seq =~ s/\s//g;
		$seq =~ s/>//;
		chomp $seq;

		if (length $seq < $limit)
		{
			++$i;
			print SH ">$code\n$seq\n";
		}
		else
		{
			++$ok;
			print LO ">$code\n$seq\n";
		}
    }
#    print OUT "$filename;$i;$ok\n";


    close (FAS);
    close (SH);
    close (LO);

#end if motif
}
# end foreach filename
}
close OUT;

exit;

############################################################


sub one_seq
{
#    read the data concernant one sequence

    my ($filename) = @_; 
    my ($res_seq) = ''; 

    my ($sep_entree) = $/;
    $/ = ">";
    $res_seq = <FAS>;
    $/ = $sep_entree;
    return $res_seq;
}


